  MEMBER

  PRAGMA('project(#compile libcurl.clw)')
  PRAGMA('project(#pragma link(libcurl.lib))')
  PRAGMA('link(honest.ico)')

  Include('Honest.inc'),Once

  Map
    Module('Honest.clw')  !  
      Honest::FormatDate(<Long inDate>,<Long inTime>),String  !   /  ( 2005-08-15T15:52:01Z ) 
      Honest::EscapeString(String sValue)String               !  JSON 
      Honest::Expired(String sDateUTC),Bool                   !   
      Honest::GetPrice(Long lPrice),String                    !                
      Honest::MarkingCodeId(String sCode),String              !      GS1                                                              
      Honest::LM_DeCodeAnswer(*Honest:G_LM_Check gCheck)      !       
    end
    
    !    : https://github.com/mikeduglas/printf
    Include('printf.inc'),Once ! -> printf('%v',) -> BASE64
  end

HonestClass.Construct  Procedure
  Code
  Self.Curl &= New TCurlClass
  Self.Curl.Init()

  Self.ResponseBuffer &= NewDynStr()         !   
  
HonestClass.Destruct   Procedure
  Code
  Dispose(Self.Curl)

  If Not (Self.ResponseBuffer &= Null)       !   
     Self.ResponseBuffer.Kill
     DisposeDynStr(Self.ResponseBuffer)
     Self.ResponseBuffer &= Null
  end
  
  Self.bFlagInit = False                     !   

HonestClass.Init       Procedure(String sToken, Long lDebugCodePage = -1) !,Bool,Proc
  Code
  Self.bFlagInit = False                     !    ()

  If Clip(sToken) = ''
     Honest::Message('     API   ʻ     !')
  else
     Self.Token         = Clip(Left(sToken)) !     API   ʻ
     Self.bFlagInit     = True               !        
     Self.DebugCodePage = lDebugCodePage     !      (  = -1 / CP_UTF8 / CP_ACP)
     
                                             !  (1 =  / 2 = ) /  Self.GetListCDN()
     Self.sRootHost     = Choose(Self.bTypeApi,Honest:RootHostProd,Honest:RootHostDemo)

     Self.SetTimeOut()                       !        Curl  
  end

  Return Self.bFlagInit
  
!!!    
HonestClass.ShowInfoText  Procedure(<String sText>)
  Code
  !      
  If Self.InfoText > 0
     If Not Omitted(sText)
        Self.InfoText{Prop:Text} = Clip(sText)
     else
        Self.InfoText{Prop:Text} = ''
     end
     Display(Self.InfoText)
  end  
 
!!!        Curl 
HonestClass.SetTimeOut Procedure(Long inTimeOut = 5)
  Code
  Self.Curl.SetOpt(CURLOPT_CONNECTTIMEOUT, inTimeOut)
  
!!!   Curl
HonestClass.SetHeaderCurl  Procedure(String sTypeRequest)  !,CurlCode,Proc
lResult  CurlCode(-1)      !      
  Code
  Self.Curl.FreeHttpHeaders()
  Self.Curl.AddHttpHeader('Content-Type: application/json; charset=utf-8')
  Self.Curl.AddHttpHeader('X-API-KEY: ' & Self.Token)
  Self.Curl.SetHttpHeaders()

  Self.Curl.SetSSLVerifyHost(False)
  Self.Curl.SetSSLVerifyPeer(False)
  Self.Curl.SetSSLVersion(CURL_SSLVERSION_DEFAULT)  

  lResult = Self.Curl.SetCustomRequest(sTypeRequest)
  If lResult = CURLE_OK and sTypeRequest = 'GET' then Self.Curl.SetHttpGET(True).

  Return lResult

!!!   (       !!!) 
HonestClass.GetToken  Procedure(String sData,*Honest:G_TokenInfo gTokenInfo) !,Bool,Proc
lResult   CurlCode(-1)
Root      &cJson
gData     Group
data        CString(1025)
          end
Json      cJSONFactory
  Code 
  If Self.SetHeaderCurl('POST') = CURLE_OK
  
     gData.data = printf('%v',sData) ! -> BASE64
     
     Root &= json::CreateObject(gData)
     If Not Root &= Null
        Self.Debug('GetToken_Request',Root,CP_ACP)
        
        Self.ResponseBuffer.Kill
        lResult = Self.Curl.SendRequest(Self.sRootHost & '/api/v3/true-api/auth/permissive-access', |
                                        Root.ToString(),Self.ResponseBuffer)

        Self.Debug('GetToken_Response',Self.ResponseBuffer)  !   
        Root.Delete()
        
        If Self.CheckResponse(lResult,'  GetToken') then Return Json.ToGroup(Self.ResponseBuffer,gTokenInfo).
     end  ! If Not Root &= Null 
  end  ! If Self.SetHeaderCurl('POST') = CURLE_OK
  
  Return False

!!!   CDN     - bLimit 
HonestClass.GetCDN  Procedure(byte bLimit = 0)
lResult     CurlCode(-1)
lCount      Long,Auto
Json        cJSONFactory
gResponse   Group(Honest:G_Result)
Hosts         &Honest:Q_CDN  !  CDN-
Host          CString(121)   !  CDN-,        /codes/check
            end
  Code
  Free(Honest:qCDN)            !   CDN 
  Honest:gCDN.lUnixTime   = 0  !    CDN 
  Honest:gCDN.bCountError = 0  ! -       CDN 

  If Self.SetHeaderCurl('GET') = CURLE_OK

     Self.ResponseBuffer.Kill
     lResult = Self.Curl.SendRequest(Choose(Self.bTypeApi,Honest:RootHostProd,Honest:RootHostDemo) & | 
                                     '/api/v4/true-api/cdn/info','',Self.ResponseBuffer)

     Self.Debug('GetCDN_Response',Self.ResponseBuffer)  !   
     If Self.CheckResponse(lResult,'  GetCDN')
     
        !Honest::Message(json::FromUTF8(Self.ResponseBuffer.Str()))
        If Not Json.ToGroup(Self.ResponseBuffer,gResponse,,'[{{"name":"hosts","instance":' & Instance(Honest:qCDN,Thread()) & | 
                                                             ',"ArraySize":' & Clip(Left(bLimit))& '}]')
              Honest::Message(': GetCDN() ->     CDN ')
        
        elsIf gResponse.code <> 0
              Honest::Message(': GetCDN() ->     , : ' & Clip(Left(gResponse.code)))
           
        elsIf Records(Honest:qCDN) = 0
              Honest::Message(': GetCDN() ->    CDN ')
        else
           Loop lCount = Records(Honest:qCDN) to 1 by -1  !    (   bLimit) 
             Get(Honest:qCDN,lCount)
             
             Honest:qCDN.Latency = Self.CheckCDN(Honest:qCDN.Host)  !    
             
             !     /     
             If Honest:qCDN.Latency > 0 then Put(Honest:qCDN) else Delete(Honest:qCDN).
             
           end  !  Loop lCount1 = Records(qCDN) to 1 by -1
        end  ! If Not Json.ToGroup(
     end  ! If Self.CheckResponse(lResult ...
  end  ! If Self.SetHeaderCurl('GET') = CURLE_OK
  
  If Records(Honest:qCDN) > 0 then Sort(Honest:qCDN,Honest:qCDN.Latency)  !  :      
  elsIf bLimit > 0            then Self.GetCDN().                         !  :       - 
  
  !    CDN 
  If Records(Honest:qCDN) > 0 then Honest:gCDN.lUnixTime = curl::UnixTime(ToDay(),Clock()).
  
!!!   CDN   
HonestClass.CheckCDN   Procedure(String sHost) !,Long 
lResult     CurlCode(-1)
lClock      Long,Auto
Json        cJSONFactory
gResponse   Group(Honest:G_Result)
avgTimeMs     Long   !       CDN-  
            end
  Code
  If Self.SetHeaderCurl('GET') = CURLE_OK

     Self.ResponseBuffer.Kill
     
     lClock  = Clock()
     lResult = Self.Curl.SendRequest(Clip(sHost) & '/api/v4/true-api/cdn/health/check','',Self.ResponseBuffer)
     lClock  = Clock() - lClock  !       (  lClock)

     Self.Debug('CheckCDN_Response',Self.ResponseBuffer)  !   
     If Self.CheckResponse(lResult,'  CheckCDN')
     
        !    
        If Json.ToGroup(Self.ResponseBuffer,gResponse) and gResponse.code = 0 then Return lClock.
        
     end  ! If Self.CheckResponse(lResult ...     
  end  ! If Self.SetHeaderCurl('GET') = CURLE_OK  
  
  Return 0

!!!      
HonestClass.CheckCodes     Procedure(Honest:Q_Codes qCodes,        |  !    
                                     String sFN,                   |  !   
                                     *Honest:G_Response gResponse, |  !    
                                     *Honest:Q_Response qResponse) !  !     
                                     
bRetVal   Byte(0)  ! 0 -    / 1 -     / 2 -    
lResult   CurlCode(-1)
lCount    Long,Auto
Root      &cJson
Json      cJSONFactory
gCodes    Group
qCodes             &Honest:Q_Codes  !  
fiscalDriveNumber  CString(17)      !   
          end        
  Code
  !   CDN  : 
  If (curl::UnixTime(ToDay(),Clock()) - Honest:gCDN.lUnixTime) > 21600 Or |  !   6  
     Honest:gCDN.bCountError > Honest:LimitErrorKM                           !  -   
     Self.GetCDN(Self.bLimitCDN)
  end   
  
  Clear(gResponse) !   
  Free( qResponse) !    
  
  Self.ShowInfoText('On-Line  ')
  
  If Self.SetHeaderCurl('POST') = CURLE_OK  
  
     Clear(gCodes)
     gCodes.qCodes           &= qCodes     !  
     gCodes.fiscalDriveNumber = Clip(sFN)  !        
  
     Root &= json::CreateObject(gCodes,,'[{{"Name":"*","EmptyString":"Ignore"},' & |
                                           '{{"Name":"fiscalDriveNumber","JsonName":"fiscalDriveNumber"},' & |
                                           '{{"Name":"qCodes","JsonName":"codes","FieldNumber":1,' & |
                                                    '"Instance":' & Instance(gCodes.qCodes,Thread()) & '}]')
     If Not Root &= Null
        Self.Debug('CheckCodes_Request',Root,CP_ACP)
             
        !     
        Loop lCount = 1 to Records(Honest:qCDN)
          Get(Honest:qCDN,lCount)

          Self.ResponseBuffer.Kill
          lResult = Self.Curl.SendRequest(Clip(Honest:qCDN.Host) & '/api/v4/true-api/codes/check',Root.ToString(),Self.ResponseBuffer)
          
          Self.Debug('CheckCodes_Response',Self.ResponseBuffer)  !   
          If Self.CheckResponse(lResult,'  CheckCodes')
          
             If json.ToGroup(Self.ResponseBuffer,gResponse,, |
                                  '[{{"name":"codes", "Instance":' & Instance(qResponse,Thread()) & '},'       & |
                                   '{{"name":["valid","verified","found","realizable","utilised","isBlocked",' & |
                                             '"isOwner","isTracking","sold","grayZone"],"IsBool":true},'       & |
                                   '{{"name":"VarDate1",  "JsonName":"1"},'  & |  !   
                                   '{{"name":"VarDate2",  "JsonName":"2"}]')      ! {"1":"VALUE1","2":"VALUE2"}
                                   
                !                                       
                If gResponse.code = 0 and Records(qResponse) > 0 then bRetVal = 1; Break else Yield.  !  
                
             end  ! If json.ToGroup( 
          end  ! If Self.CheckResponse(lResult ...
        end  ! Loop lCount1 = 1 to qCDN
     
        Root.Delete()
     end  ! If Not Root &= Null 
  end  ! If Self.SetHeaderCurl('POST') = CURLE_OK
  
  ! ---     
  
  If bRetVal = 1
  
     Loop lCount = 1 to Records(qResponse)
       Get(qResponse,lCount)
       
       !        
       If qResponse.errorCode > Honest:ErrorCode00
       
          qResponse.LockFlag  = 100 + qResponse.errorCode
          
          Execute qResponse.errorCode            
            qResponse.LockName  = '  '
            qResponse.LockName  = '   GTIN'
            qResponse.LockName  = '    '
            qResponse.LockName  = '   '
            qResponse.LockName  = '  -  ( -    )'
            qResponse.LockName  = '  -  (  )'
            qResponse.LockName  = '  -  (-  )'
            qResponse.LockName  = '      '
            qResponse.LockName  = ' AI    '
            qResponse.LockName  = '     '
            qResponse.LockName  = '    '
          else
            qResponse.LockName  = '    : ' & Clip(Left(qResponse.errorCode))
          end
          
       elsIf Not qResponse.found  !  
          qResponse.LockFlag  = 01
          qResponse.LockName  = '      '
          
       elsIf Not qResponse.utilised
          qResponse.LockFlag  = 01
          qResponse.LockName  = '  ,      '          
          
       elsIf Not qResponse.verified
          qResponse.LockFlag  = 02
          qResponse.LockName  = '     '

       elsIf qResponse.sold
          qResponse.LockFlag  = 03
          qResponse.LockName  = '    '

       elsIf qResponse.isBlocked
          qResponse.LockFlag  = 04
          qResponse.LockName  = '     '
          
       !         grayZone = True
       elsIf Not qResponse.sold and Not qResponse.realizable and |       
             Not (qResponse.groupIds[(Honest:Tobacco)] and qResponse.grayZone)
             
          qResponse.LockFlag  = 05
          qResponse.LockName  = '       '

       !  ,    ,  
       elsIf (qResponse.groupIds[(Honest:Milk)] Or | 
              qResponse.groupIds[(Honest:Beer)] Or | 
              qResponse.groupIds[(Honest:Water)]) and Honest::Expired(qResponse.expireDate) 
           
          qResponse.LockFlag  = 06
          qResponse.LockName  = '   '
       
       !   ->  
       elsIf qResponse.groupIds[(Honest:Tobacco)]

          Clear(gCodes.qCodes) 
          Get(gCodes.qCodes,lCount)
          If ErrorCode()
             Honest::Message('      : ' & qResponse.cis)
             
          elsIf qResponse.mrp > 0 and gCodes.qCodes.Price > qResponse.mrp
             qResponse.LockFlag  = 07
             qResponse.LockName  = '    (' &             Honest::GetPrice(gCodes.qCodes.Price) & | 
                                   ')     (' & Honest::GetPrice(qResponse.mrp) & ')'
             
          elsIf qResponse.smp > 0 and gCodes.qCodes.Price < qResponse.smp
             qResponse.LockFlag  = 07
             qResponse.LockName  = '    (' &             Honest::GetPrice(gCodes.qCodes.Price) & | 
                                   ')     (' &  Honest::GetPrice(qResponse.smp) & ')'
          end  ! If ErrorCode() 
       end  ! If Clip(qResponse.cis) = ''
       
       If qResponse.LockFlag = 0 
          qResponse.LockName = ' '
       else
          bRetVal = 2  !     (-)
       end   
          
       Put(qResponse)  !    
     end  ! Loop lCount1 = 1 to Records(qResponse)
  else
     ! -    (   CDN )
     Honest:gCDN.bCountError += 1 
  end  ! If bRetVal = 1
  
  Self.ShowInfoText()  
  Return bRetVal

!!!    ( )    
HonestClass.CheckOneCode   Procedure(String sCodeGS1,Real rMRZ = 0) !,Byte
qCodes      Queue(Honest:Q_Codes).
gResponse   Group(Honest:G_Response).
qResponse   Queue(Honest:Q_Response).

  Code  
  Clear(qCodes)
  qCodes.GS1   = sCodeGS1                !    GS1: '0104690228107191215vMt/<29>93HVOST' ...
  qCodes.Price = Round(rMRZ,0.01) * 100  !     
  Add(qCodes)

  !    
  If Self.CheckCodes(qCodes,'',gResponse,qResponse) = 1   !  ->   

     Get(qResponse,1)  !      
     If Not ErrorCode() then Return qResponse.LockFlag.
  end
  
  Return 254  !    

!!!   
HonestClass.CheckResponse  Procedure(*CurlCode xResult_,String xPlace_,Long lExceptionCode = -137137) !,Bool
Json        cJSONFactory
gResponse   Group(Honest:G_Result).
  Code
  If Not xResult_ = CURLE_OK
     If Not Self.SilentCurl
        Honest::Message(' Curl: ' & xPlace_ & '|' & Self.Curl.StrError(xResult_))
     end   

  elsIf InList(Self.Curl.GetResponseCode(),200,lExceptionCode) = 0

     If Json.ToGroup(Self.ResponseBuffer,gResponse)     
        If Not Self.SilentCurl
           Honest::Message(' : '    & xPlace_                     & '|'  & |
                           '   : ' & Self.Curl.GetResponseCode() & '||' & |
                           ' : '           & gResponse.Code              & '|'  & |
                           ': '               & gResponse.description)
        end                   
                        
     elsIf Not Self.SilentCurl
        Honest::Message(' : '    & xPlace_                     & '||' & | 
                        '   : ' & Self.Curl.GetResponseCode() & '|'  & | 
                         json::FromUTF8(Self.ResponseBuffer.Str()))
     end

     xResult_ = 99
  end

  Return Choose(xResult_ = CURLE_OK,True,False)

!!!       
HonestClass.Debug   Procedure(String sFileName, String sText,     Long lTextCodePage = CP_UTF8)
  Code
  If    Self.DebugCodePage = -1  !   
  elsIf Self.DebugCodePage = lTextCodePage then json::SaveFile(Honest:MyDebugPath & sFileName & '.json', sText)
  else  json::SaveFile(Honest:MyDebugPath & sFileName & '.json', json::ConvertEncoding(sText, lTextCodePage, Self.DebugCodePage)).
  
!!!       
HonestClass.Debug   Procedure(String sFileName, *IDynStr iBuffer, Long lTextCodePage = CP_UTF8)
  Code
  If Not iBuffer &= Null then Self.Debug(sFileName,iBuffer.Str(),lTextCodePage).

!!!   JSON     
HonestClass.Debug   Procedure(String sFileName, *cJSON jObject,   Long lTextCodePage = CP_UTF8)
  Code
  If Not jObject &= Null then Self.Debug(sFileName,jObject.ToString(True),lTextCodePage).
  
!!!   Queue     
HonestClass.Debug   Procedure(String sFileName, *Queue qList,     Long lTextCodePage = CP_UTF8)
Root &cJson
  Code
  If Self.DebugCodePage <> -1  !     
  
     !  ! Bool    Byte     
     Root &= json::CreateArray(qList)  ! ,,'[' & Honest:J_ALL & ']'
     If Not Root &= Null
        Self.Debug(sFileName,Root.ToString(True),lTextCodePage)
        Root.Delete()
     end  
  end
  
! --------------------------------------------------------------------------------------------------
! ---   -----------------------------------------------------------------------------
! --------------------------------------------------------------------------------------------------
  
!!!    
HonestClass.LM_SetParam   Procedure(String sUser,String sPass,String sFN)
  Code
  Self.LM_AU = printf('%v',Clip(sUser) & ':' & Clip(sPass))  ! Authorization
  Self.LM_FN = Clip(sFN)                                     ! X-ClientId  
  
!!!   Curl  
HonestClass.LM_SetHeader  Procedure(String sTypeRequest)  !,Bool,Proc
lResult  CurlCode(-1)
  Code
  Self.Curl.FreeHttpHeaders()
  Self.Curl.AddHttpHeader('Content-Type: application/json')
  Self.Curl.AddHttpHeader('Authorization: Basic ' & Self.LM_AU)
  
  If Self.LM_FN <> '' then Self.Curl.AddHttpHeader('X-ClientId: ' & Self.LM_FN).
  Self.Curl.SetHttpHeaders()

  Self.Curl.SetSSLVerifyHost(False)
  Self.Curl.SetSSLVerifyPeer(False)
  Self.Curl.SetSSLVersion(CURL_SSLVERSION_DEFAULT)  

  lResult = Self.Curl.SetCustomRequest(sTypeRequest)
  If lResult = CURLE_OK and sTypeRequest = 'GET' then Self.Curl.SetHttpGET(True).

  Return Choose(lResult = CURLE_OK)
  
!!!     ʻ (     )
HonestClass.LM_FirstContact  Procedure  !,Bool,Proc  
lResult  CurlCode(-1)
sData    CString(121)

  Code
  If Self.LM_SetHeader('POST')
  
     sData = '{{"token":' & Honest::EscapeString(Self.Token) & '}'
     Self.Debug('LM_Init_Request',sData,CP_ACP)          !  
        
     Self.ResponseBuffer.Kill
     lResult = Self.Curl.SendRequest(Honest:RootHostLocal & '/api/v1/init',sData,Self.ResponseBuffer)
     Self.Debug('LM_Init_Response',Self.ResponseBuffer)  !   
     
     If Self.CheckResponse(lResult,'  LM_Init')
        Honest::Message('    ʻ   !')
        Return True
     end
  end  ! Self.LM_SetHeader('POST') = CURLE_OK
  
  Return False  

!!!       ʻ
HonestClass.LM_Status  Procedure(*Honest:G_LM_Status gStatus,Bool bOnlyReady = False)  !,Bool,Proc  
lResult  CurlCode(-1)
Json     cJSONFactory
bRetVal  Bool(False)
  Code
  If Self.LM_SetHeader('GET')

     Self.ResponseBuffer.Kill
     lResult = Self.Curl.SendRequest(Honest:RootHostLocal & '/api/v1/status',,Self.ResponseBuffer)
     Self.Debug('LM_Status_Response',Self.ResponseBuffer)  !   
     
     If Self.CheckResponse(lResult,'  LM_Status')
        bRetVal = Json.ToGroup(Self.ResponseBuffer,gStatus)
     end
     
     If Not bOnlyReady  !   
        Return bRetVal
        
     elsIf Not bRetVal  ! ,    
        Honest::Message('   !||' & |
                        '      ʻ.|' & |
                        '       .||' & |
                        '     ʻ  / = admin/admin.')
        Return False                
                        
     elsIf gStatus.Status = 'not_configured'
        Honest::Message('      ʻ.')
        Return False

     elsIf gStatus.Status = 'initialization'
        Honest::Message('     ʻ.')
        Return False

     elsIf gStatus.Status = 'sync_error'
        Honest::Message('     ʻ.')
        Return False
     
     elsIf gStatus.Status <> 'ready'
        Honest::Message('     ʻ: ' & gStatus.Status)
        Return False
     end     
  end  ! Self.LM_SetHeader('GET') = CURLE_OK
  
  Return bRetVal
  
!!!    ( )
HonestClass.LM_CheckCodes  Procedure(Honest:Q_Codes qCodes,*Honest:Q_LM_Check qCheck) !,Byte  
lResult  CurlCode(-1)
bRetVal  Byte(0)
lCount   Long 

Root     &cJson
Json     cJSONFactory

qList    Queue
ID         CString(201)  !   
         end
          
gRequest Group
cis_list   &Queue
         end
  Code   
  Self.ShowInfoText('Off-Line  ')
  Free(qCheck)  !     
  
  Self.Debug('LM_CheckCodes_Request1',qCodes,CP_ACP)  !      
  
  If Self.LM_SetHeader('POST')
  
     Free(qList)  !        
     Loop lCount = 1 to Records(qCodes)  
       Get(qCodes,lCount)
       
       Clear(qList)
       qList.ID = Honest::MarkingCodeId(qCodes.GS1)  !       GS1
       Add(qList)
     end  
     
     Clear(gRequest)
     gRequest.cis_list &= qList  !  
  
     Root &= json::CreateObject(gRequest,,'[{{"Name":"*","EmptyString":"Ignore"},' & |
                                           '{{"Name":"cis_list","FieldNumber":1,'  & |
                                             '"Instance":' & Instance(gRequest.cis_list,Thread()) & '}]')
     Free(qList)

     If Not Root &= Null
        Self.Debug('LM_CheckCodes_Request2',Root,CP_ACP)  !      
        
        Self.ResponseBuffer.Kill
        lResult = Self.Curl.SendRequest(Honest:RootHostLocal & '/api/v1/cis/outCheck',Root.ToString(),Self.ResponseBuffer)
        
        Self.Debug('LM_CheckCodes_Response1',Self.ResponseBuffer)     
        If Self.CheckResponse(lResult,'  LM_CheckCode')  !   
        
           If Json.ToQueue(Self.ResponseBuffer,'results',qCheck,,'[' & Honest:J_LM_IdCode & ']')
           
              !  
              Loop lCount = 1 to Records(qCheck)
                Get(qCheck,lCount)
                
                Honest::LM_DeCodeAnswer(qCheck)  !        
                
                If bRetVal = 0 then bRetVal = 1. !       
                                                 !       
                If bRetVal = 1 and qCheck.LockFlag <> 0 then bRetVal = 2.
                
                Put(qCheck)                      !                  
              end  ! Loop lCount = 1 to Records(qCheck)
           end  ! If json.ToQueue(
        end  ! If Self.CheckResponse(lResult ...
     
        Root.Delete()
     end  ! If Not Root &= Null 
  end  ! If Self.SetHeaderCurl('POST') = CURLE_OK
  
 !                   
  Self.Debug('LM_CheckCodes_Response2',qCheck,CP_ACP)
  
  Self.ShowInfoText()  
  Return bRetVal  
  
!!!       (On-Line / Off-Line)
HonestClass.CheckReceipt  Procedure(*Honest:Q_Codes qCodes,         |  !   GS1  
                                    String          sToken,         |  !    API   ʻ 
                                    String          sLM_User,       |  !          ʻ
                                    String          sLM_Password,   |  !       ʻ                                    
                                    String          sFN,            |  !   
                                    Long            lDebugCodePage, |  !    
                                    Bool            bSilentMode     |  !    :  !
                                    ) !,Bool                            
bRetVal    Bool(False)
lCount     Long,Auto
bHonestOK  Byte,Auto

gResponse  Group(Honest:G_Response).   !     (On-Line)
qResponse  Queue(Honest:Q_Response).   !     

qCheck     Queue(Honest:Q_LM_Check).   !     (Off-Line)
gStatus    Group(Honest:G_LM_Status).  !     ʻ

  Code  
  Self.bLimitCDN  = 3     !   -  CDN 
  Self.SilentCurl = True  !    
  
  !       -
  ! ***    ***
  
  !  
  Self.Init(sToken,lDebugCodePage)
  
  !   On-Line       
  bHonestOK = Self.CheckCodes(qCodes,sFN,gResponse,qResponse)
 !bHonestOK = 0  ! DEBUG:     
 
  If InRange(bHonestOK,1,2)  ! 1 =   / 2 =  
  
     Execute bHonestOK
       bRetVal = True        ! 1 =  
                             ! 2 =  
       If Not bSilentMode and |
          Honest::AskMe(' !!!| On-Line    .||   ?')
          bRetVal = True
       end   
     end     

     If bRetVal = True
     
        !   On-Line  
        Loop lCount = 1 to Records(qCodes)
          Get(qCodes,lCount)
          
          json::DeepClear(qResponse)
          Get(qResponse,lCount)
          If Not ErrorCode() !and qResponse.LockFlag = 0    !     (    )
             qCodes.reqId         = gResponse.reqId         !          (   !)
             qCodes.reqTimestamp  = gResponse.reqTimestamp  !       UTC (   !)
             Put(qCodes)
          end  ! If Not ErrorCode()
        end  ! Loop lCount = 1 to Records(qCodes)
     end  ! If InRange(bHonestOK,1,2)
  
  !            ʻ
  elsIf Clip(sLM_User) <> '' and Clip(sLM_Password) <> ''

     !        ʻ
     Self.LM_SetParam(sLM_User,sLM_Password,sFN)
     
     !      ʻ
     If Self.LM_Status(gStatus,True)
        
        !   Off-Line   
        bHonestOK = Self.LM_CheckCodes(qCodes,qCheck)
        If InRange(bHonestOK,1,2)  ! 1 =   / 2 =  
        
           Execute bHonestOK
             bRetVal = True  ! 1 =  
                             ! 2 =  
             If Not bSilentMode and |
                Honest::AskMe(' !!!| Off-Line    .||   ?')
                bRetVal = True
             end   
           end     

           If bRetVal = True
           
              !   Off-Line  
              Loop lCount = 1 to Records(qCodes)
                Get(qCodes,lCount)

                json::DeepClear(qCheck)
                Get(qCheck,lCount)
                If Not ErrorCode() and qCheck.LockFlag = 0
                   qCodes.reqId         = qCheck.reqId         !   
                   qCodes.reqTimestamp  = qCheck.reqTimestamp  !      ( UTC)
                   qCodes.Inst          = qCheck.Inst          !       ʻ
                   qCodes.Version       = qCheck.Version       !    ,     
                   Put(qCodes)                  
                end  ! If Not ErrorCode() and qCheck.reqId = ''                
              end  ! Loop lCount = 1 to Records(qCodes)  
           end  ! If bRetVal = True
        end  ! If InRange(bHonestOK,1,2)
       
     else
        Honest::Message(' !!!||' & | 
                        '     ( )    ʻ|'            & |
                        '       -      ʻ.|'  & |
                        '     ʻ  / = admin/admin.||'           & |
                        '  .     .')                        
     end  ! If Self.LM_Status(gStatus,True)      
  end  ! If InRange(bHonestOK,1,2)
  
  !   ,           ʻ  
  If bRetVal = True
  
     Loop lCount = 1 to Records(qCodes)
       Get(qCodes,lCount)
       
       If qCodes.reqId = '' Or qCodes.reqTimestamp = ''
          If Not bSilentMode
             Honest::Message(' !!!||' & ' : ' & qCodes.GS1 & '|'               & |
                             '        ʻ||' & |
                             '  .     .'). 

             bRetVal = False  !   
          Break
       end
     end  
  end

  Return bRetVal
  
! --------------------------------------------------------------------------------------------------
! ---   --------------------------------------------------------------------------
! --------------------------------------------------------------------------------------------------

!!!   
Honest::Message    Procedure(String sText)
  Code
  Message(sText, '   ʻ','~honest.ico', '&1. ')

!!!   
Honest::AskMe      Procedure(String sText) !,Bool
  Code
  Return Choose(Message(sText,'   ʻ','~honest.ico',Button:Yes + Button:No,Button:Yes) = 2, True, False)
  
!!!     
Honest::View       Procedure(*Queue qList)
Root    &cJSON
  Code       
  Root &= json::CreateArray(qList)
  If Not Root &= Null
     Honest::Message(Root.ToString(True))
     Root.Delete()  
  end  

!!!   /  ( 2005-08-15T15:52:01Z )
Honest::FormatDate   Procedure(<Long inDate>, <Long inTime>) !, String
  Code
  If Omitted(inDate) then inDate = ToDay().
  If Omitted(inTime) then inTime = Clock().
  Return Format(inDate,@D10-) & 'T' & Format(inTime,@T04) & 'Z'  ! !2005-08-15T15:52:01Z
  
!!!  JSON 
Honest::EscapeString  Procedure(String sValue) !, String
jTag      &cJson
RetVal    Any
  Code
  jTag  &= json::CreateString(sValue)
  RetVal = jTag.ToString()
  jTag.Delete()
  Return RetVal  

!!!    2005-08-15T15:52:01Z   
Honest::Expired  Procedure(String sDateUTC) !,Bool
RetVal  Bool(False)
lDate   Long,Auto
lTime   Long,Auto
  Code
  
  If Clip(sDateUTC) <> '' and Sub(sDateUTC,11,01) = 'T'
     
     lDate = DeFormat(Sub(sDateUTC,01,10),@D10-)
     
     If lDate > 0
        If    lDate < ToDay() then RetVal = True
        elsIf lDate = ToDay()
           lTime = DeFormat(Sub(sDateUTC,12,08),@T04)
           If lTime < Clock() then RetVal = True.
        end   
     end
  end
  
  Return RetVal

!!!      
Honest::GetPrice Procedure(Long lPrice) !,String
  Code
  Return Clip(Left(Format(lPrice / 100,@n20.2~ .~)))  
  
!!!   ( )   ( )  GS1
Honest::MarkingCodeId  Procedure(String sCode) !,String
lGS     Long,Auto
sCIS    String(Size(sCode))             !  ( )

  Code
  sCode = Clip(Left(sCode))             !  
  
  If Len(Clip(sCode)) = 29              !  (  = 29)
     sCIS = Sub(sCode,01,21)            !  = 14 GTIN + 7 SERIAL ( 4  + 4 )
  else
     lGS = InString(Chr(29),sCode,1,1)  !    <29>  KM
     If lGS > 1
        sCIS = Sub(sCode,01,lGS - 1)    !  =    
     else   
        sCIS = sCode                    !  = 
     end
  end
  
 !Return printf('%u',Clip(sCIS))        !   RFC 1738 (  11  05.06.2025 .  RFC 1738)
  Return Clip(sCIS)                     !  
  
!!!       (On-Line / Off-Line)
Honest::CheckReceipt  Procedure(*Honest:Q_Codes qCodes,         |  !   GS1  
                                String          sToken,         |  !    API   ʻ 
                                String          sLM_User,       |  !          ʻ
                                String          sLM_Password,   |  !       ʻ                                    
                                String          sFN,            |  !   
                                Long            lDebugCodePage, |  !    
                                Bool            bSilentMode,    |  !    :  !
                                uShort          uInfoText = 0   |  !    
                                ) !,Bool  
                                
xHonest  HonestClass  !    API   
  Code
  xHonest.InfoText = uInfoText  !    
  
  Return xHonest.CheckReceipt(qCodes,          |  !   GS1  
                              sToken,          |  !  
                              sLM_User,        |  !          ʻ
                              sLM_Password,    |  !       ʻ                                            
                              sFN,             |  !   
                              lDebugCodePage,  |  !    
                              bSilentMode      |  !    (- )     
                              )

!!!                                     
Honest::GetProductGroups  Procedure(Byte[] aGroupIds, Bool bOnlyFirst = False) !,String
bCount  Byte,Auto
sRetVal CString(513)
  Code
  Loop bCount = 1 to Maximum(aGroupIds,1)
    If    aGroupIds[bCount] = 0     then Break
    elsIf bOnlyFirst and bCount = 2 then Break
    else
       sRetVal = Clip(sRetVal) & Choose(bCount = 1,'',', ') & |
       Choose(aGroupIds[bCount],' ', |
                                ' ', |
                                ' ', |
                                '   ', |
                                '   ()', |
                                '', |
                                ' ', |
                                ' ', |
                                '  ', |
                                ' ', |
                                '11', |
                                '  ', |
                                ' ', |
                                '   ', |
                                ',  ', |
                                ' ', |
                                '  ', |
                                '18', |
                                ' ', |
                                '  ', |
                                '', |
                                ' ', |
                                '   ', | ! 23
                                '24', |
                                '25', |
                                ' ', | ! 26
                                '27', |
                                '28', |
                                '29', |
                                '30', |
                                '31', |
                                ' ', | ! 32
                                ' ', | ! 33
                                '???')
    end
  end  
    
  Return sRetVal
  
!!!     
Honest::CheckUniqueCodes  Procedure(String sMarkingCode,                |
                                    *Honest:Q_UniqueCodes qUniqueCodes, |
                                    String sFractionalAmount,           |
                                    String sTName) !,Bool
  Code
  
  !      
  If Clip(sMarkingCode) <> '' and Clip(sFractionalAmount) = ''
  
     Clear(qUniqueCodes) 
     qUniqueCodes.MarkingCode = Clip(Left(sMarkingCode))
     Get(qUniqueCodes,qUniqueCodes.MarkingCode)
     If ErrorCode()
        Clear(qUniqueCodes) 
        qUniqueCodes.MarkingCode = Clip(Left(sMarkingCode))
        Add(qUniqueCodes,qUniqueCodes.MarkingCode)
     else
        If Clip(sTName) <> ''
           Honest::Message(' !||' & |
                           ' : ' & Clip(sTName) & '||' & |
                           '    : ' & Clip(sMarkingCode))
        end   
        Return False
     end
  end
  
  Return True

!         
Honest::LM_DeCodeAnswer Procedure(*Honest:G_LM_Check gCheck)

  Code
  If gCheck.code <> 0               !      
     gCheck.LockFlag = gCheck.code
     gCheck.LockName = gCheck.description          
                                    !    
  elsIf gCheck.Codes[1].isBlocked = True
     gCheck.LockFlag = 04
     gCheck.LockName = '     '
     
  elsIf gCheck.Codes[1].isGreyGtin = True
     gCheck.LockFlag = 15 !   ,       :(
     gCheck.LockName = 'GTIN       GTIN'                   
  else
     gCheck.LockName = ' '                   
  end 
  
!!!     
!Honest::MyTest  Procedure()
!Root       &cJson
!Json       cJSONFactory
!  Code

! ---      

!!!    ( ) 
!!!   11  05.06.2025 .   GET v1/cis/outCheck   RFC 1738
!HonestClass.LM_CheckCode  Procedure(String sCodeGS1,*Honest:G_LM_Check gCheck) !,Bool,Proc  
!lResult  CurlCode(-1)  
!sCIS     CString(201)     !   
!Json     cJSONFactory
!
!  Code
!  If Self.LM_SetHeader('GET')
!  
!     sCIS = Honest::MarkingCodeId(sCodeGS1)  !    RFC 1738    GS1
!                                             !   
!     Self.Debug('LM_CheckCode_Request','{{' & Honest::EscapeString(sCIS) & '}',CP_ACP)  
!
!     Self.ResponseBuffer.Kill
!     
!    !   01.09.2025 . ! 
!    !lResult = Self.Curl.SendRequest(Honest:RootHostLocal & '/api/v1/cis/check?cis=' & sCIS,,Self.ResponseBuffer)
!    
!     lResult = Self.Curl.SendRequest(Honest:RootHostLocal & '/api/v1/cis/outCheck?cis=' & sCIS,,Self.ResponseBuffer)     
!     Self.Debug('LM_CheckCode_Response',Self.ResponseBuffer)
!     
!     If Self.CheckResponse(lResult,'  LM_CheckCode')
!        If Json.ToGroup(Self.ResponseBuffer,gCheck,,'[' & Honest:J_LM_IdCode & ']')
!        
!           Honest::LM_DeCodeAnswer(gCheck)  !       
!           Return True
!        end   
!     end   
!  end  ! Self.LM_SetHeader('GET') = CURLE_OK
!  
!  Return False  
  
!!!    -        (      )
!HonestClass.LM_CheckCodes  Procedure(Honest:Q_Codes qCodes,*Honest:Q_LM_Check qCheck) !,Byte
!bRetVal   Byte(0)
!lCount    Long,Auto
!gCheck    Group(Honest:G_LM_Check).
!
!  Code  
!  !    
!  Self.Debug('LM_CheckCodes_Request',qCodes,CP_ACP)
!  
!  !     
!  Free(qCheck)  
!  
!  Self.ShowInfoText('Off-Line  ')
!  
!  !   
!  Loop lCount = 1 to Records(qCodes)
!    Get(qCodes,lCount)
!
!    !   
!    If Self.LM_CheckCode(qCodes.GS1,qCheck)    
!       Add(qCheck)
!       If Not ErrorCode()       
!          !                
!          If bRetVal = 0 then bRetVal = 1.  
!          
!          !       
!          If bRetVal = 1 and qCheck.LockFlag <> 0 then bRetVal = 2.
!       end   
!    end
!  end
!                !    
!  Self.Debug('LM_CheckCodes_Response',qCheck,CP_ACP)  
!  Self.ShowInfoText()
!  
!  Return bRetVal