!     
!   17.06.2025 .
! ------------------------------------------------
!  :  https://forum.clarionlife.net
! LibCurl & cJSON: https://github.com/mikeduglas
! ------------------------------------------------

  Include('libcurl.inc'),Once     ! -> Include('DynStr.inc'),Once
  Include('cJSON.inc'),Once       !  ! : true/false -  lowercase !
           
  ! ---  

  Map
    Module('Honest')
      Honest::Message(String sText)        ! 
      Honest::AskMe(String sText),Bool     !   
      Honest::View(*Queue qList)           !     
                                           !                                     
      Honest::GetProductGroups(Byte[] aGroupIds, Bool bOnlyFirst = False),String  
      
                                           !     
      Honest::CheckUniqueCodes(String sMarkingCode,                |
                               *Honest:Q_UniqueCodes qUniqueCodes, |
                               String sFractionalAmount,           |
                               String sTName),Bool
      
                                           !       (On-Line / Off-Line)
      Honest::CheckReceipt(*Honest:Q_Codes qCodes,         |  !   GS1  
                           String          sToken,         |  !    API   ʻ
                           String          sLM_User,       |  !          ʻ
                           String          sLM_Password,   |  !       ʻ
                           String          sFN,            |  !                             
                           Long            lDebugCodePage, |  !    
                           Bool            bSilentMode,    |  !    :  !
                           uShort          uInfoText = 0   |  !    
                           ),Bool      
    end
  end

  ! ---  ( !   REST  -  !)
  
!    TYPE / VARIABLE
! L / l -> LONG
! B / b -> BYTE (BOOL)    
! R / r -> REAL
! D / d -> DECIMAL
! S / s -> STRING
! C / c -> CSTRING
! G / g -> GROUP
! Q / q -> QUEUE
! I / i -> IDynStr
! J / j -> cJSON OPTIONS

!!!        (   !)
Honest:MyDebugPath   Equate('Debug\Honest_')

!!!  REST   ʻ
Honest:RootHostProd  Equate('https://cdn.crpt.ru')
Honest:RootHostDemo  Equate('https://markirovka.sandbox.crptech.ru')

!!!      ʻ
Honest:RootHostLocal Equate('http://127.0.0.1:5995')

!!!    JSON 
Honest:J_ALL         Equate('{{"Name":"*","EmptyString":"ignore","IgnoreZero":true,"IgnoreEmptyObject":true,"IgnoreEmptyArray":true,"IgnoreFalse":true}')

!!!     Q_Response.packageType
Honest:UNIT          Equate(' ')
Honest:GROUP         Equate(' ')
Honest:BUNDLE        Equate('')
Honest:SET           Equate('')

!!!     Q_Response.errorCode
Honest:ErrorCode00   Equate(00)      !  
Honest:ErrorCode01   Equate(01)      !   
Honest:ErrorCode02   Equate(02)      !    GTIN
Honest:ErrorCode03   Equate(03)      !     
Honest:ErrorCode04   Equate(04)      !    
Honest:ErrorCode05   Equate(05)      !   -  ( -    )
Honest:ErrorCode06   Equate(06)      !   -  (  )
Honest:ErrorCode07   Equate(07)      !   -  (-  )
Honest:ErrorCode08   Equate(08)      !       
Honest:ErrorCode09   Equate(09)      !  AI    
Honest:ErrorCode10   Equate(10)      !      
Honest:ErrorCode11   Equate(11)      !     

!!!     Q_Response.GroupIds
                   Itemize,Pre(Honest)
Lp                   Equate(01)      !  ,  , ,   
Shoes                Equate(02)      !  
Tobacco              Equate(03)      !  
Perfumery            Equate(04)      !    
Tires                Equate(05)      !      
Electronics          Equate(06)      !  ( ),   
Pharma               Equate(07)      !     
Milk                 Equate(08)      !  
Bicycle              Equate(09)      !    
Wheelchairs          Equate(10)      !  
HZ11                 Equate(11)
Otp                  Equate(12)      !   
Water                Equate(13)      !  
Furs                 Equate(14)      !    
Beer                 Equate(15)      ! , ,    ,  
Ncp                  Equate(16)      !  
Bio                  Equate(17)      !     
HZ18                 Equate(18)
Antiseptic           Equate(19)      !    
Petfood              Equate(20)      !    
Seafood              Equate(21)      ! 
Nabeer               Equate(22)      !  
Softdrinks           Equate(23)      !     
HZ24                 Equate(24)
HZ25                 Equate(25)
Vetpharma            Equate(26)      !   
HZ27                 Equate(27)
HZ28                 Equate(28)
HZ29                 Equate(29)
HZ30                 Equate(30)
HZ31                 Equate(31)
Conserve             Equate(32)      !   
Vegetableoil         Equate(33)      !   
                   end

!!!                     
Honest:G_TokenInfo Group,Type
access_token         CString(37)     !  
id_token             CString(81)     !  
expires_in           CString(21)     !     integer($int64)
token_type           CString(41)     !  
                   end

!!!  CDN 
Honest:Q_CDN       Queue,Type
Host                 CString(121)    !  CDN 
Latency              Long            !    
                   end

!!!                       
Honest:Q_Codes     Queue,Type
GS1                  CString(201)    ! Name('code'):     GS1: '0104690228107191215vMtz<29>93HVOST'
                                     ! #   
Price                Long            ! #       ..
FractionalAmount	 CString(41)     ! 1291    
reqId                CString(37)     !   
reqTimestamp         CString(21)     !      ( UTC)
Inst                 CString(37)     !       ʻ 
Version              CString(37)     !    ,      
                   end

!!!                      
Honest:G_Result    Group,Type
code                 Long            !   
description          CString(256)    !      
                   end

!!!    
Honest:G_Response  Group(Honest:G_Result),Type
reqId                CString(37)     !   
reqTimestamp         CString(21)     !      ( UTC)
                                     !     (   ,  )
Codes                &Honest:Q_Response
                   end

Honest:ProductGroups Equate(23)      ! -  
Honest:MaxOgvs       Equate(03)      ! -   

!!!                      
Honest:Q_Response  Queue,Type
cis                  CString(201)    !   
printView            CString(201)    !   -
gtin                 CString(21)     !   GTIN
valid                Bool(False)     !     
verified             Bool(False)     !    
found                Bool(False)     !    ( /  )
realizable           Bool(False)     !    
utilised             Bool(False)     !     
isBlocked            Bool(False)     !  ,        
isOwner              Bool(False)     ! ,      
isTracking           Bool(False)     !      
sold                 Bool(False)     !      
grayZone             Bool(False)     !       
                                     ! *    
groupIds             Byte,Dim(Honest:ProductGroups)
                                     ! * :   ,    
ogvs                 CString(31),Dim(Honest:MaxOgvs)
productionDate       CString(31)     !   
expireDate           CString(31)     !                                        
variableExpirations  Group           !      
VarDate1               CString(31)
VarDate2               CString(31)
                     end
productWeight        Long            !    ( )
errorCode            Long            !   (0 =  )
message              CString(256)    !    
packageType          CString(21)     !  
producerInn          CString(21)     !  
prVetDocument        CString(81)     !    
mrp                  Long            !    (   )
smp                  Long            !       (   )
eliminationState     Long            !    
innerUnitCount       Long            !       /   /   
soldUnitCount        Long            !     
parent               CString(256)    !  
                                     ! #  
LockFlag             Byte(0)         ! #       
LockName             CString(256)    ! #    
                   end 
                  
Honest:LimitErrorKM  Equate(5)       ! -       CDN 
 
!!!   CDN 
Honest:gCDN        Group,Static    
lUnixTime            ULong(0)        !    CDN 
bCountError          Byte(0)         ! -    (   CDN )
qCDN                 &Honest:Q_CDN   !  CDN  (  )
                   end 
                                     !  CDN   
Honest:qCDN        Queue(Honest:Q_CDN),Static.

!!! ---   () ---------------------------------------------------------------------

!!!  
Honest:G_LM_Status Group,Type
lastSync             Decimal(14)     !      UnixTime  ()
version              CString(21)     !      ʻ
inst                 CString(37)     !       ʻ
name                 CString(21)     !   
status               CString(21)     !      ʻ
operationMode        CString(21)     !   
requiresDownload     CString(21)     ! ,     
replicationStatus    Group           ! -  
cis                    Group         ! -- 
timeLag                  CString(21) !           
serverDocCount           CString(21) !       
localDocCount            CString(21) !     
                       end
blocked_series         Group
timeLag                  Long        !           
serverDocCount           Long        !       
localDocCount            Long        !     
                       end
blocked_gtin           Group
timeLag                  Long        !           
serverDocCount           Long        !       
localDocCount            Long        !     
                       end
blocked_cis            Group
timeLag                  Long        !           
serverDocCount           Long        !       
localDocCount            Long        !     
                       end
                     end
dbVersion            CString( 21)    !     
serviceUrl           CString(256)    !   () 
lastUpdate           ULong           !         UnixTime  ()
inn                  CString( 21)    !      
                   end
                   
!!!  ( )
Honest:G_LM_IdCode Group,Type
printView            CString(99)     ! 
isBlocked            Bool            !  ,        
isGreyGtin           Bool            ! , ,  GTIN       GTIN 
gtin                 CString(15)     !   GTIN
cis                  CString(99)     !   
                   end
Honest:J_LM_IdCode Equate('{{"name":["isBlocked","isGreyGtin"],"IsBool":true}')

!!!      
Honest:G_LM_Check  Group,Type
reqId                CString(37)     !   
reqTimestamp         CString(21)     !      ( UTC)
code                 Long            !   
description          CString(99)     !     
inst                 CString(37)     !       ʻ
version              CString(37)     !    ,     
                                     !  
codes                Group(Honest:G_LM_IdCode),Dim(2).
                                     ! #  
LockFlag             Long(0)         ! #       
LockName             CString(256)    ! #    
                   end
                   
!!!       
Honest:Q_LM_Check  Queue(Honest:G_LM_Check),Type
                   end
                   
!!!        Honest::CheckUniqueCodes
Honest:Q_UniqueCodes  Queue,Type
MarkingCode             CString(201)
                      end                    

!!!  Honest
HonestClass  Class,Type,Module('Honest.clw'),Link('Honest.clw')
Curl           &TCurlClass,Private   !   Curl
ResponseBuffer &IDynStr,Private      !    

Token          CString(41),Private   !  API   

bTypeApi       Byte(1)               !  (1 =  / 2 = )
sRootHost      CString(121),Private  !   

bLimitCDN      Byte(0)               !   -  CDN  (0 =  )

bFlagInit      Bool(False)           !   
DebugCodePage  Long(-1),Private      !       (  = -1)
SilentCurl     Bool(False)           !    CURL
InfoText       UShort(0)             !   

Construct      Procedure
Destruct       Procedure
Init           Procedure(String sToken,Long lDebugCodePage = -1),Bool,Proc

!!!     Curl  
SetTimeOut     Procedure(Long inTimeOut = 5)
!!!   Curl
SetHeaderCurl  Procedure(String sTypeRequest),CurlCode,Private
!!!       Curl
CheckResponse  Procedure(*CurlCode xResult_,String xPlace_,Long lExceptionCode = -137137),Bool,Private
!!!    
ShowInfoText   Procedure(<String sText>),Private

!!!   
Debug          Procedure(String sFileName, String   sText,   Long lTextCodePage = CP_UTF8),Private
Debug          Procedure(String sFileName, *IDynStr iBuffer, Long lTextCodePage = CP_UTF8),Private
Debug          Procedure(String sFileName, *cJSON   jObject, Long lTextCodePage = CP_UTF8),Private
Debug          Procedure(String sFileName, *Queue   qList,   Long lTextCodePage = CP_UTF8),Private

!!!  
GetToken       Procedure(String sData,*Honest:G_TokenInfo gTokenInfo),Bool,Proc
!!!   CDN 
GetCDN         Procedure(byte bLimit = 0),Private
!!!   CDN 
CheckCDN       Procedure(String sHost),Long,Private

!!!    ( ) 
CheckCodes     Procedure(Honest:Q_Codes qCodes,String sFN,*Honest:G_Response gResponse,*Honest:Q_Response qResponse),Byte
!!!      (  )
CheckOneCode   Procedure(String sCodeGS1,Real rMRZ = 0),Byte

!!! ---   () ---------------------------------------------------------------------

LM_AU           CString(99)           !    Base64(Login:Password)
LM_FN           CString(17)           !   ()

!!!    
LM_SetParam     Procedure(String sUser,String sPass,String sFN)  
!!!   Curl  
LM_SetHeader    Procedure(String sTypeRequest),Bool,Proc
!!!     ʻ (     )
LM_FirstContact Procedure(),Bool,Proc  

!!!       ʻ
LM_Status       Procedure(*Honest:G_LM_Status gStatus,Bool bOnlyReady = False),Bool,Proc
!!!    ( )   
LM_CheckCodes   Procedure(Honest:Q_Codes qCodes,*Honest:Q_LM_Check qCheck),Byte

!!!       (On-Line / Off-Line)
CheckReceipt    Procedure(*Honest:Q_Codes qCodes,         |  !   GS1  
                          String          sToken,         |  !    API   ʻ
                          String          sLM_User,       |  !          ʻ
                          String          sLM_Password,   |  !       ʻ
                          String          sFN,            |  !                             
                          Long            lDebugCodePage, |  !    
                          Bool            bSilentMode     |  !    :  !
                          ),Bool
             end

! ---      
             
!!!    ( )
!!LM_CheckCode    Procedure(String sCodeGS1,*Honest:G_LM_Check gCheck),Bool,Proc            